#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, k; cin >> n >> k;
    string s; cin >> s;
    if (n<=5 && k==2)
    {
    if (n==1)
    {
        cout << 1 << endl;
        return 0;
    }
    if (n==2)
    {
        cout << 1 << " ";
        if (s=="ab" || s=="ba") cout << 2 << endl;
        else cout << 1 << endl;
        return 0;
    }
    if (n==3)
    {
        cout << 1 << " ";
        string a=s.substr(0, 2);
        if (a=="ab" || a=="ba") cout << 2 << " ";
        else cout << 1 << " ";
        if (s=="aaa" || s=="bbb") cout << 1 << endl;
        else  cout << 2 << endl;
        return 0;
    }
    if (n==4)
    {
        cout << 1 << " ";
        string a=s.substr(0, 2);
        if (a=="ab" || a=="ba") cout << 2 << " ";
        else cout << 1 << " ";
        a=s.substr(0, 3);
        if (a=="aaa" || a=="bbb") cout << 1 << " ";
        else  cout << 2 << " ";
        if (s=="aaaa" || s=="bbbb") cout << 1 << endl;
        else  cout << 2 << endl;
        return 0;
    }
    if (n==5)
    {
        cout << 1 << " ";
        string a=s.substr(0, 2);
        if (a=="ab" || a=="ba") cout << 2 << " ";
        else cout << 1 << " ";
        a=s.substr(0, 3);
        if (a=="aaa" || a=="bbb") cout << 1 << " ";
        else  cout << 2 << " ";
        a=s.substr(0, 4);
        if (a=="aaaa" || a=="bbbb") cout << 1 << " ";
        else  cout << 2 << " ";
        if (s=="aaaaa" || s=="bbbbb") cout << 1 << " ";
        bool aa=false; bool ab=false;
        bool ba=false; bool bb=false;
        for (int i=0; i<n-2; i++)
        {
            if (s.substr(i, 2)=="aa") aa=true;
            if (s.substr(i, 2)=="ab") ab=true;
            if (s.substr(i, 2)=="bb") bb=true;
            if (s.substr(i, 2)=="ba") ba=true;
        }
        if (aa && bb && ba && ab) cout << 3 << endl;
        else cout << 2 << endl;
        return 0;
    }
    }
    return 0;
}